﻿using StepII.OrderStates;
using System;
using System.Collections.Generic;

namespace StepII
{
    public class Order
    {
        private OrderState _orderState;
        public Order(IEnumerable<OrderLine> orderLines, ShippingDetails shippingDetails, InvoiceDetails invoiceDetails)
        {
            _orderState = new Concept(orderLines, shippingDetails, invoiceDetails);
        }

        public void AddOrderLine(string description, decimal price)
        {
            _orderState = _orderState.AddOrderLine(description, price);
        }

        public void RemoveOrderLine(Guid orderlineIdentifier)
        {
            _orderState = _orderState.RemoveOrderLine(orderlineIdentifier);
        }

        public void Cancel()
        {
            _orderState = _orderState.Cancel();
        }

        public void FinalizeOrder()
        {
            _orderState = _orderState.FinalizeOrder();
        }

        public void Pay()
        {
            _orderState = _orderState.Pay();
        }

        public void ShipOrder()
        {
            _orderState = _orderState.ShipOrder();
        }
    }
}
