﻿using System;
using System.Collections.Generic;

namespace StepII
{
    public class ToRemove : OrderState
    {
        public ToRemove(IEnumerable<OrderLine> orderLines, ShippingDetails shippingDetails, InvoiceDetails invoiceDetails, OrderStatus orderStatus)
            : base(orderLines, shippingDetails, invoiceDetails)
        {
            OrderStatus = orderStatus;
        }

        public override OrderState AddOrderLine(string description, decimal price)
        {
            throw new InvalidOperationException("An order can only be altered when it is still in concept.");
        }

        public override OrderState RemoveOrderLine(Guid orderlineIdentifier)
        {
            throw new InvalidOperationException("An order can only be altered when it is still in concept.");
        }

        public override OrderState Cancel()
        {
            throw new InvalidOperationException("An order can only be canceled when it is still in concept.");
        }

        public override OrderState FinalizeOrder()
        {
            throw new InvalidOperationException("An order can only be finalized when it is still in concept.");
        }

        public override OrderState Pay()
        {
            if (OrderStatus != OrderStatus.Ordered)
            {
                throw new InvalidOperationException("An order can only be payed when it is final.");
            }

            return this;
        }

        public override OrderState ShipOrder()
        {
            if (OrderStatus != OrderStatus.Paid)
            {
                throw new InvalidOperationException("An order can only be shipped when it is payed.");
            }

            VerifyShippingDetails();

            var shippingDate = _shippingGateway.DetermineShippingDate(this);
            _shippingDetails.SetShippingDate(shippingDate);


            OrderStatus = OrderStatus.Shipped;
            return this;
        }

        // etc etc etc
        // Irrelevant private's below..

        private void VerifyShippingDetails()
        {
            ; // Let's pretend that everything is in order (pun intended)
        }

    }
}
