﻿using System;
using System.Collections.Generic;

namespace StepIII.OrderStates
{
    internal class Canceled : OrderState
    {
        public Canceled(IEnumerable<OrderLine> orderlines, ShippingDetails shippingDetails, InvoiceDetails invoiceDetails)
            : base(orderlines, shippingDetails, invoiceDetails)
        {
        }

        public override OrderState AddOrderLine(string description, decimal price)
        {
            return ThrowNotAllowed();
        }

        public override OrderState Cancel()
        {
            return ThrowNotAllowed();
        }

        public override OrderState FinalizeOrder()
        {
            return ThrowNotAllowed();
        }

        public override OrderState Pay()
        {
            return ThrowNotAllowed();
        }

        public override OrderState RemoveOrderLine(Guid orderlineIdentifier)
        {
            return ThrowNotAllowed();
        }

        public override OrderState ShipOrder()
        {
            return ThrowNotAllowed();
        }

        private OrderState ThrowNotAllowed()
        {
            throw new NotSupportedException("This action is not supported on cancelled orders");
        }
    }
}
