﻿using System;
using System.Collections.Generic;

namespace StepIII.OrderStates
{
    internal class Shipped : OrderState
    {
        public Shipped(IEnumerable<OrderLine> orderLines, ShippingDetails shippingDetails, InvoiceDetails invoiceDetails)
            : base(orderLines, shippingDetails, invoiceDetails)
        {
        }

        public override OrderState AddOrderLine(string description, decimal price)
        {
            return ThrowNotSupported();
        }

        public override OrderState Cancel()
        {
            return ThrowNotSupported();
        }

        public override OrderState FinalizeOrder()
        {
            return ThrowNotSupported();
        }

        public override OrderState Pay()
        {
            return ThrowNotSupported();
        }

        public override OrderState RemoveOrderLine(Guid orderlineIdentifier)
        {
            return ThrowNotSupported();
        }

        public override OrderState ShipOrder()
        {
            return ThrowNotSupported();
        }

        private OrderState ThrowNotSupported()
        {
            throw new NotSupportedException("Mutating a shipped order is not possible");
        }
    }
}
